import vs,sfm,sfmApp,sfmUtils

#Animset for Clips v1.0.5
#created BY http://steamcommunity.com/id/OMGTheresABearInMyOatmeal/



#simple obj used to hold info on making the slider controls
class Sliderobj():
     
     def __init__(self, settingname,groupname,minval,maxval,default,color=False):        

          self.name=settingname
          self.controlgroup=groupname
          self.minValue=minval
          self.maxValue=maxval
          self.default=default
          self.isColor=color

     


#the folling dicts holds which controls are created from each clip type

DmeSoundClip_dict={
    'Volume':Sliderobj('volume','SoundControls',0.0,1.0,1.0),
    'Pitch':Sliderobj('pitch','SoundControls',0.0,300.0,100.0),
    'Level':Sliderobj('level','SoundControls',0.0,100.0,0.0)
}


DmeColorCorrectionFXClip_dict={
     'Weight':Sliderobj('weight','EffectsControls',0.0,100.0,1.0)
}

DmeViewportFXClip_dict={
     'Scale_X':Sliderobj('scalex','EffectsControls',-20.0,20.0,1.0),
     'Scale_Y':Sliderobj('scaley','EffectsControls',-20.0,20.0,1.0),
     'Offset_X':Sliderobj('offsetx','EffectsControls',-2.0,2.0,0.0),
     'Offset_Y':Sliderobj('offsety','EffectsControls',-2.0,2.0,0.0)
}

DmeMaterialOverlayFXClip_dict={
     'Color':Sliderobj('overlaycolor','ColorControls',0.0,1.0,1.0,True),
     'Fullscreen':Sliderobj('fullscreen','EffectsControls',0.0,1.0,1.0),
     'MovementSpeed':Sliderobj('movementSpeed','EffectsControls',-1000.0,1000.0,0.0),
     'MovementAngle':Sliderobj('movementAngle','EffectsControls',-360.0,360.0,0.0),
     'UseSubRect':Sliderobj('useSubRect','EffectsControls',0.0,1.0,0.0),
     'SubRectTop':Sliderobj('subRectTop','EffectsControls',-100.0,100.0,0.0),
     'SubRectLeft':Sliderobj('subRectLeft','EffectsControls',-100.0,100.0,0.0),
     'SubRectWidth':Sliderobj('subRectWidth','EffectsControls',-100.0,100.0,0.0),
     'SubRectHeight':Sliderobj('subRectHeight','EffectsControls',-100.0,100.0,0.0)
     
}

DmeHSLGrainFXClip_dict={
     'Hue':Sliderobj('hue','EffectsControls',-20.0,20.0,0.0),
     'Saturation':Sliderobj('saturation','EffectsControls',-100.0,100.0,0.0),
     'Lightness':Sliderobj('lightness','EffectsControls',-3.0,3.0,.075)
}

DmeTextFXClip_dict={
     'Color':Sliderobj('textColor','ColorControls',0.0,1.0,1.0,True),
     'HorizontalAlignment':Sliderobj('horizontalAlignment','EffectsControls',-2.0,2.0,0.0),
     'VerticalAlignment':Sliderobj('verticalAlignment','EffectsControls',-2.0,2.0,0.0),
     'x_Offset':Sliderobj('xOffset','EffectsControls',-1000.0,1000.0,0.0),
     'y_Offset':Sliderobj('yOffset','EffectsControls',-1000.0,1000.0,0.0),
     'x_Speed':Sliderobj('xSpeed','EffectsControls',-100.0,100.0,0.0),
     'y_Speed':Sliderobj('ySpeed','EffectsControls',-100.0,100.0,0.0)

}


DmeEnginePostFXClip_dict={
     'Enable_bloom':Sliderobj('bloom','EffectsControls',0.0,1.0,0.0),
     'BloomAmount':Sliderobj('bloomAmount','EffectsControls',-100.0,100.0,0.0),
     'Enable_vignette':Sliderobj('vignette','EffectsControls',0.0,1.0,1.0),
     'Enable_noise':Sliderobj('noise','EffectsControls',0.0,1.0,1.0),
     'NoiseScale':Sliderobj('noiseScale','EffectsControls',0.0,100.0,1.0),
     'Enable_localContrast':Sliderobj('localContrast','ContrastControls',0.0,1.0,1.0),
     'localContrastScale':Sliderobj('localContrastScale','ContrastControls',-100.0,100.0,0.5),
     'localContrastMidToneMask':Sliderobj('localContrastMidToneMask','ContrastControls',-100.0,100.0,0.0),
     'localContrastVignetteStart':Sliderobj('localContrastVignetteStart','ContrastControls',-2.0,2.0,0.7),
     'localContrastVignetteEnd':Sliderobj('localContrastVignetteEnd','ContrastControls',-2.0,2.0,1.0),
     'localContrastEdgeScale':Sliderobj('localContrastEdgeScale','ContrastControls',-2.0,2.0,0.0),
     'Enable_blurredVignette':Sliderobj('blurredVignette','EffectsControls',0.0,1.0,0.0),
     'blurredVignetteScale':Sliderobj('blurredVignetteScale','EffectsControls',-100.0,100.0,0.0),
     'colorCorrectionWeight':Sliderobj('colorCorrectionWeight','EffectsControls',-100.0,100.0,1.0),
     'Enable_TVGamma':Sliderobj('TVGamma','EffectsControls',0.0,1.0,0.0),
     'Enable_Desaturation':Sliderobj('Desaturation Enable','EffectsControls',0.0,1.0,0.0),
     'Desaturation':Sliderobj('Desaturation','EffectsControls',-100.0,100.0,0.0)     
     
}





def CreateAnimset(animsetName,parentgroup):
     shot = sfm.GetCurrentShot()
     
      
     newdag= vs.CreateElement("DmeDag", animsetName, shot.GetFileId())   

     shot.scene.FindOrAddChild(parentgroup).children.AddToTail(newdag)
     
     newAnimSet = sfm.CreateAnimationSet(animsetName, target=newdag)
     
     #hides the transform dag, could also del it
     controlGroup = newAnimSet.FindOrAddControlGroup(newAnimSet.GetRootControlGroup(), "all")
     controlGroup.SetVisible(False)
     controlGroup.SetSelectable(False)
     
     return newAnimSet

def calLerpVal(value, lo, hi):
     return (abs(lo-value)/abs(hi-lo))
     


def AddColorControl(animset,outelm,slidername,sliderobj):
     shot = sfm.GetCurrentShot()
     controlGroup = animset.FindOrAddControlGroup(animset.GetRootControlGroup(), sliderobj.controlgroup)     
     controlGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)
     
     Expr=vs.CreateElement("DmePackColorOperator","Color_pack",shot.GetFileId())     
     animset.AddOperator(Expr)
     

     Red_Control = sfmUtils.CreateControlAndChannel( slidername+"_red", vs.AT_FLOAT, 1.0, animset, shot )
     Red_Control.channel.toElement = Expr
     Red_Control.channel.toAttribute = "red"
     Red_Control.channel.SetMode(3)  
     controlGroup.AddControl(Red_Control) 
     
     
     Green_Control = sfmUtils.CreateControlAndChannel( slidername+"_green", vs.AT_FLOAT, 1.0, animset, shot )
     Green_Control.channel.toElement = Expr
     Green_Control.channel.toAttribute = "green"
     Green_Control.channel.SetMode(3)  
     controlGroup.AddControl(Green_Control)      
     
     
     Blue_Control = sfmUtils.CreateControlAndChannel( slidername+"_blue", vs.AT_FLOAT, 1.0, animset, shot )
     Blue_Control.channel.toElement = Expr
     Blue_Control.channel.toAttribute = "blue"
     Blue_Control.channel.SetMode(3)  
     controlGroup.AddControl(Blue_Control)      
     
     
     Alpha_Control = sfmUtils.CreateControlAndChannel( slidername+"_alpha", vs.AT_FLOAT, 1.0, animset, shot )
     Alpha_Control.channel.toElement = Expr
     Alpha_Control.channel.toAttribute = "alpha"
     Alpha_Control.channel.SetMode(3)  
     controlGroup.AddControl(Alpha_Control)      
     
     
     #connects the output of expr to output elm
     Conn = sfmUtils.CreateConnection("Connection_ColorPack" , Expr, "color", animset)
     Conn.AddOutput(outelm, sliderobj.name)      
     


def AddControl(animset,outelm,slidername,sliderobj):
     shot = sfm.GetCurrentShot()
     controlGroup = animset.FindOrAddControlGroup(animset.GetRootControlGroup(), sliderobj.controlgroup)     
     controlGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)
     
      # Creating an operator/expression, to adapt the 0.0 -> 1.0 float information provided by the slider
     Expr = sfmUtils.CreateExpression( slidername+"_rescale", "lerp( value, lo, hi)", animset )
     Expr.SetValue( "value",  sliderobj.default )
     Expr.SetValue( "lo", sliderobj.minValue )
     Expr.SetValue( "hi",    sliderobj.maxValue)


     #creates the slider
     Control = sfmUtils.CreateControlAndChannel( slidername, vs.AT_FLOAT, calLerpVal(sliderobj.default ,sliderobj.minValue,sliderobj.maxValue ), animset, shot )
     Control.channel.toElement = Expr
     Control.channel.toAttribute = "value"
     Control.channel.SetMode(3)    
     controlGroup.AddControl(Control) 

     #connects the output of expr to output elm
     Conn = sfmUtils.CreateConnection("Connection"+ "_" + slidername, Expr, "result", animset)
     Conn.AddOutput(outelm, sliderobj.name) 
     
     

###################################################################







def ErrorBox(e):
     #error box
     from PySide import  QtGui
     msgBox = QtGui.QMessageBox(QtGui.QMessageBox.Critical,
                               "ERROR", str(e),
            QtGui.QMessageBox.NoButton)

     font = QtGui.QFont()
     font.setPointSize(10)
     msgBox.setFont(font)
     msgBox.addButton("&Retry", QtGui.QMessageBox.RejectRole)
     if msgBox.exec_() == QtGui.QMessageBox.AcceptRole:pass
     
def CreateChannel(name, animSet, shot):
     channel = vs.CreateElement( "DmeChannel", name, shot.GetFileId() )
     
     
     log = vs.CreateElement( "DmeVector3Log", "vector3 log", shot.GetFileId() )
     channel.SetLog( log )
     #log.SetKey( vs.DmeTime_t( 0 ), vs.Vector( 0, 0, 0 ) );     
     channel.mode = 3
     
     channelsClip = sfmUtils.GetChannelsClipForAnimSet( animSet, shot )
     if ( channelsClip != None ) :
          channelsClip.channels.AddToTail( channel )
     return channel

SelectedClips=sfmClipEditor.GetSelectedClips("CDmeFXClip")
SelectedClips.extend(sfmClipEditor.GetSelectedClips("CDmeSoundClip"))

if len(SelectedClips)>0:
     for elm in SelectedClips:
          
          
          if elm.GetTypeString()=='DmeSoundClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Sound Clips")
               
               controlGroup = AnimSet.FindOrAddControlGroup(AnimSet.GetRootControlGroup(), "all")
               controlGroup.SetVisible(True)
               controlGroup.SetSelectable(True)   
               #for 3d sound
               channel=CreateChannel("transform_origin_pos",AnimSet,sfm.GetCurrentShot())
               channel.SetInput(AnimSet.dag.transform,"position")
               channel.SetOutput(elm.sound,"origin")
               
               
               for slidername in DmeSoundClip_dict:
                    AddControl(AnimSet,elm.sound,slidername,DmeSoundClip_dict[slidername])          


          elif  elm.GetTypeString()=='DmeViewportFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")
               
               for slidername in DmeViewportFXClip_dict:
                    AddControl(AnimSet,elm,slidername,DmeViewportFXClip_dict[slidername]) 

          elif  elm.GetTypeString()=='DmeMaterialOverlayFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")
               
               for slidername in DmeMaterialOverlayFXClip_dict:
                    
                    if DmeMaterialOverlayFXClip_dict[slidername].isColor:
                         AddColorControl(AnimSet,elm,slidername,DmeMaterialOverlayFXClip_dict[slidername]) 
                    else:
                         AddControl(AnimSet,elm,slidername,DmeMaterialOverlayFXClip_dict[slidername]) 
        
          elif  elm.GetTypeString()=='DmeHSLGrainFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")
               
               for slidername in DmeHSLGrainFXClip_dict:
                    AddControl(AnimSet,elm,slidername,DmeHSLGrainFXClip_dict[slidername]) 
         
         
          elif  elm.GetTypeString()=='DmeTextFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")             
               
               for slidername in DmeTextFXClip_dict:
                    
                    if DmeTextFXClip_dict[slidername].isColor:
                         AddColorControl(AnimSet,elm,slidername,DmeTextFXClip_dict[slidername]) 
                    else:
                         AddControl(AnimSet,elm,slidername,DmeTextFXClip_dict[slidername]) 


          elif  elm.GetTypeString()=='DmeEnginePostFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")
               
               for slidername in DmeEnginePostFXClip_dict:
                    AddControl(AnimSet,elm,slidername,DmeEnginePostFXClip_dict[slidername]) 
         

          elif  elm.GetTypeString()=='DmeColorCorrectionFXClip':
               
               AnimSet=CreateAnimset(elm.GetName(),"Overlay Clips")
               
               for slidername in DmeColorCorrectionFXClip_dict:
                    AddControl(AnimSet,elm,slidername,DmeColorCorrectionFXClip_dict[slidername])  

else:
     ErrorBox("You need to select at least one Sound or Overlay Clip")










